using System.Threading;

namespace Todo.Core.Interfaces.Persistence;

public interface ITodoRepository
{
    Task<Entities.Todo> CreateTodoAsync(
        string title,
        string? projectName,
        string? description,
        string? priority,
        string userId,
        long created);

    Task<IEnumerable<Entities.Todo>> GetTodosAsync(string userId, CancellationToken cancellationToken = new());

    Task UpdateTodoStatus(
        string todoId,
        bool todoStatus,
        string userId);

    Task<Entities.Todo> GetTodoByIdAsync(string todoId);
    Task<Entities.Todo> UpdateTodoAsync(Entities.Todo todo);
    Task<IEnumerable<Entities.Todo>> GetActiveTodosAsync(string authorId, CancellationToken cancellationToken = new());
}